###################################################
### chunk number 1: loadLibs
###################################################
#line 122 "foreach.Rnw"
library(foreach)


###################################################
### chunk number 2: ex1
###################################################
#line 136 "foreach.Rnw"
x <- foreach(i=1:3) %do% sqrt(i)
x


###################################################
### chunk number 3: ex2
###################################################
#line 157 "foreach.Rnw"
x <- foreach(a=1:3, b=rep(10, 3)) %do% (a + b)
x


###################################################
### chunk number 4: ex3
###################################################
#line 164 "foreach.Rnw"
x <- foreach(a=1:3, b=rep(10, 3)) %do% {
  a + b
}
x


###################################################
### chunk number 5: ex4
###################################################
#line 178 "foreach.Rnw"
x <- foreach(a=1:1000, b=rep(10, 2)) %do% {
  a + b
}
x


###################################################
### chunk number 6: ex5
###################################################
#line 198 "foreach.Rnw"
x <- foreach(i=1:3, .combine='c') %do% exp(i)
x


###################################################
### chunk number 7: ex6
###################################################
#line 211 "foreach.Rnw"
x <- foreach(i=1:4, .combine='cbind') %do% rnorm(4)
x


###################################################
### chunk number 8: ex7
###################################################
#line 221 "foreach.Rnw"
x <- foreach(i=1:4, .combine='+') %do% rnorm(4)
x


###################################################
### chunk number 9: ex7.1
###################################################
#line 229 "foreach.Rnw"
cfun <- function(a, b) NULL
x <- foreach(i=1:4, .combine='cfun') %do% rnorm(4)
x


###################################################
### chunk number 10: ex7.2
###################################################
#line 244 "foreach.Rnw"
cfun <- function(...) NULL
x <- foreach(i=1:4, .combine='cfun', .multicombine=TRUE) %do% rnorm(4)
x


###################################################
### chunk number 11: ex7.2
###################################################
#line 253 "foreach.Rnw"
cfun <- function(...) NULL
x <- foreach(i=1:4, .combine='cfun', .multicombine=TRUE, .maxcombine=10) %do% rnorm(4)
x


###################################################
### chunk number 12: ex7.3
###################################################
#line 272 "foreach.Rnw"
foreach(i=4:1, .combine='c') %dopar% {
  Sys.sleep(3 * i)
  i
}
foreach(i=4:1, .combine='c', .inorder=FALSE) %dopar% {
  Sys.sleep(3 * i)
  i
}


###################################################
### chunk number 13: ex8
###################################################
#line 300 "foreach.Rnw"
x <- foreach(a=irnorm(4, count=4), .combine='cbind') %do% a
x


###################################################
### chunk number 14: ex9
###################################################
#line 313 "foreach.Rnw"
set.seed(123)
x <- foreach(a=irnorm(4, count=1000), .combine='+') %do% a
x


###################################################
### chunk number 15: ex10
###################################################
#line 322 "foreach.Rnw"
set.seed(123)
x <- numeric(4)
i <- 0
while (i < 1000) {
  x <- x + rnorm(4)
  i <- i + 1
}
x


###################################################
### chunk number 16: ex11
###################################################
#line 335 "foreach.Rnw"
set.seed(123)
x <- foreach(icount(1000), .combine='+') %do% rnorm(4)
x


###################################################
### chunk number 17: ex12.data
###################################################
#line 372 "foreach.Rnw"
x <- matrix(runif(500), 100)
y <- gl(2, 50)


###################################################
### chunk number 18: ex12.load
###################################################
#line 380 "foreach.Rnw"
library(randomForest)


###################################################
### chunk number 19: ex12.seq
###################################################
#line 394 "foreach.Rnw"
rf <- foreach(ntree=rep(250, 4), .combine=combine) %do%
  randomForest(x, y, ntree=ntree)
rf


###################################################
### chunk number 20: ex12.par
###################################################
#line 406 "foreach.Rnw"
rf <- foreach(ntree=rep(250, 4), .combine=combine, .packages='randomForest') %dopar%
  randomForest(x, y, ntree=ntree)
rf


###################################################
### chunk number 21: ex13.orig
###################################################
#line 431 "foreach.Rnw"
applyKernel <- function(newX, FUN, d2, d.call, dn.call=NULL, ...) {
  ans <- vector("list", d2)
  for(i in 1:d2) {
    tmp <- FUN(array(newX[,i], d.call, dn.call), ...)
    if(!is.null(tmp)) ans[[i]] <- tmp
  }
  ans
}
applyKernel(matrix(1:16, 4), mean, 4, 4)


###################################################
### chunk number 22: ex13.first
###################################################
#line 448 "foreach.Rnw"
applyKernel <- function(newX, FUN, d2, d.call, dn.call=NULL, ...) {
  foreach(i=1:d2) %dopar%
    FUN(array(newX[,i], d.call, dn.call), ...)
}
applyKernel(matrix(1:16, 4), mean, 4, 4)


###################################################
### chunk number 23: ex13.second
###################################################
#line 464 "foreach.Rnw"
applyKernel <- function(newX, FUN, d2, d.call, dn.call=NULL, ...) {
  foreach(x=iter(newX, by='col')) %dopar%
    FUN(array(x, d.call, dn.call), ...)
}
applyKernel(matrix(1:16, 4), mean, 4, 4)


###################################################
### chunk number 24: ex13.iter
###################################################
#line 479 "foreach.Rnw"
iblkcol <- function(a, chunks) {
  n <- ncol(a)
  i <- 1

  nextElem <- function() {
    if (chunks <= 0 || n <= 0) stop('StopIteration')
    m <- ceiling(n / chunks)
    r <- seq(i, length=m)
    i <<- i + m
    n <<- n - m
    chunks <<- chunks - 1
    a[,r, drop=FALSE]
  }

  structure(list(nextElem=nextElem), class=c('iblkcol', 'iter'))
}
nextElem.iblkcol <- function(obj) obj$nextElem()


###################################################
### chunk number 25: ex13.third
###################################################
#line 499 "foreach.Rnw"
applyKernel <- function(newX, FUN, d2, d.call, dn.call=NULL, ...) {
  foreach(x=iblkcol(newX, 3), .combine='c', .packages='foreach') %dopar% {
    foreach(i=1:ncol(x)) %do% FUN(array(x[,i], d.call, dn.call), ...)
  }
}
applyKernel(matrix(1:16, 4), mean, 4, 4)


###################################################
### chunk number 26: when
###################################################
#line 525 "foreach.Rnw"
x <- foreach(a=irnorm(1, count=10), .combine='c') %:% when(a >= 0) %do% sqrt(a)
x


###################################################
### chunk number 27: qsort
###################################################
#line 534 "foreach.Rnw"
qsort <- function(x) {
  n <- length(x)
  if (n == 0) {
    x
  } else {
    p <- sample(n, 1)
    smaller <- foreach(y=x[-p], .combine=c) %:% when(y <= x[p]) %do% y
    larger  <- foreach(y=x[-p], .combine=c) %:% when(y >  x[p]) %do% y
    c(qsort(smaller), x[p], qsort(larger))
  }
}

qsort(runif(12))


